	subroutine adjust

C	SUBROUTINE THAT ADJUSTS INPUT VELOCITY TO MEET OUTPUT BOUNDARY CONDITIONS

C	DECLARE VARIABLES USED IN THIS SUBROUTINE

	implicit none

	real*8  mach(10000),pres(10000),vel(10000),v1m(100),v1o(100),
     *		v1p(100),z(10000),zlm(100),zlp(100)
	real*8 crit,eps,int,slope,rmaxo,rminv,vellast
	integer i,ifinal,im,ip,iruns,j

C	DECLARE VARIABLES IN THE COMMON BLOCK BUT NOT USED IN THIS
C	SUBROUTINE

	real*8 area(10000),re(10000),rho(10000),vesic(10000),
     *		visc(10000),wtoxan(9)
      real*8 beta,blkmag,bubnum,Ca,cp,cpm,
     *		cv,dadz,dfinal,dfirst,dh2o,dhdp,diam,dpdz,dvdz,dz,
     *		emax,enthalpy,entropy,eta,etagas,etamag,
     *		exmol,f,fo,g,gamma,h,hf,m,mdot,mg,mh2o,mm,
     *		msil,mw,mwttot,mxtls,pfinal,r,rey,rhof,rhom,rhomix,
     *		rhoxtls,s,
     *		sv,temp,v,vex,vfgas,vm,vxtls,xsarea,xtls,zfinal
	integer icalc,iend,ifrag,io,itherm,ives

C	COMMON BLOCKS

	  Common/block1/area,mach,pres,re,
     *		rho,vel,vesic,visc,z
        Common/block2/beta,bubnum,Ca,cp,cv,
     *		dadz,dfinal,dfirst,dhdp,diam,dpdz,dvdz,dz,
     *		emax,eps,eta,etagas,etamag,
     *		exmol,f,fo,g,gamma,h,hf,m,mdot,mg,mh2o,mm,
     *		msil,mw,mxtls,pfinal,r,rey,rhof,rhomix,
     *		rhoxtls,s,
     *		sv,temp,v,vex,vfgas,vm,vxtls,xsarea,xtls,zfinal
 	  Common/ints/i,icalc,iend,ifinal,ifrag,im,ip,io,
     *		iruns,itherm,ives
 	  common/melt/blkmag,cpm,dh2o,enthalpy,entropy,mwttot,rhom,wtoxan

C	IF THIS IS THE FIRST RUN, INITIALIZE RMINV, RMAXO
	if (iruns.eq.1) then
		rminv = 5.0d+05
	    rmaxo = 0.d00
	end if

	vellast = vel(1)

c	write (10,4512) vel(1), z(i), mach(i), pres(i)/1.0d+06, iruns,
c     *		rminv, rmaxo
c4512	format (4f12.4,i6,2f12.4)

C*********************************************************************

C	SOLUTIONS FOR Z=ZFINAL

C*********************************************************************

	if (z(i).eq.zfinal) then

C	IF Z(I)=ZFINAL AND P>PFINAL, SEE IF THERE ARE PREVIOUS CALCULATIONS
C	RESULTING IN M>1 OR P<PFINAL.  IF SO, INCREASE VEL(1) BY 0.2 
C	TIMES THE DIFFERENCE BETWEEN THE MINIMUM V1M OR V1P AND THE 
C	MAXIMUM V1O

C	VARIABLES:
C	  V1O = INPUT VELOCITY FOR A RUN THAT RESULTED IN P>PFINAL, Z=ZFINAL
C	  V1P =  "       "      "  "  "    "     "     "  P<PFINAL, Z<ZFINAL
C	  V1M =  "       "      "  "  "    "     "     "  M>1, Z<ZFINAL
C	  IO =  NUMBER OF RUNS THAT RESULTED IN P>PFINAL, Z=ZFINAL
C	  IP =     "   "   "     "     "      " P<PFINAL, Z<ZFINAL
C	  IM =     "   "   "     "     "      " M>1, Z<ZFINAL
C	

	  if (pres(i).gt.pfinal) then
	    write (6,*) 'exit pressure > pfinal and M < 1'
	    write (9,*) 'exit pressure > pfinal and M < 1'
	    v1o(io) = vel(1)
		if (v1o(io).gt.rmaxo) rmaxo = v1o(io)
	    io = io+1

cC	FIND MINIMUM OF V1P AND V1M

c	    rminv = 5.d+05
c	    do 150 j=1,im-1
c150	    rminv=min(rminv,v1m(j))
c	    do 160 j=1,ip-1
c160	    rminv=min(rminv,v1p(j))

C	FIND MAXIMUM OF V1O

c	    rmaxo = 0.
c	    do 170 j=1,io-1
c170	    rmaxo=max(rmaxo,v1o(j))

C	CALCULATE NEW VALUE OF VEL(1)
	     if (rminv.lt.5.d+05) then
	      vel(1) = rmaxo + 0.5*(rminv-rmaxo)
	     else
	      vel(1) = 1.5*vel(1)
	    end if
	    go to 500

C	IF Z=ZFINAL AND THE FINAL PRESSURE IS <(ZFINAL-.0001) MPA, 
C	ADJUST THE INITIAL VELOCITY SO THAT IT'S HALFWAY BETWEEN 
C	THE CURRENT VEL(1) AND THE MAXIMUM V1O

	  else
	    v1p(ip) = vel(1)
c	    do 171 j=1,io-1
c171	    rmaxo=max(rmaxo,v1o(j))
	    vel(1) = rmaxo + 0.5*(vel(1)-rmaxo)
	    if (vel(1).gt.rmaxo) rmaxo = vel(1)
	    if (vel(1).lt.0.001) vel(1) = 0.001
	    ip = ip+1
	    go to 500
	  end if
	end if

C*********************************************************************

C	SOLUTIONS FOR Z < ZFINAL

C*********************************************************************

C	IF M>1, THE RELATIONSHIP BETWEEN (Z(I)-ZFINAL) AND VEL(1) SHOULD BE
C	ALMOST LINEAR.  THEREFORE, IF WE HAVE RUN AT LEAST
C	TWO ITERATIONS WHERE VEL(1) AND Z(I) HAVE BEEN OBTAINED,
C	WE CAN USE THOSE VALUES TO DEFINE THE LINE RELATING Z(I) AND
C	VEL(1), AND CALCULATE THE VEL(1) NEEDED TO OBTAIN M=1 AT
C	Z(I) = ZFINAL.   THIS VALUE IS VEL(1)=-INT/SLOPE, WHERE INT IS THE
C	Z(I) INTERCEPT OF THE Z(I) VS VEL(1) LINE, AND SLOPE IS THE
C	SLOPE OF THE LINE.

C	IT TURNS OUT THAT, IF ONE ASSUMES THE RELATIONSHIP
C	BETWEEN (Z(I)-ZFINAL) AND VEL(1) TO BE PERFECTLY LINEAR, ONE OVERSHOOTS
C	AND ENDS UP BACK IN THE M<1 FIELD.  THEREFORE, I ADD 10% OF 
C	THE DIFFERENCE BETWEEN THE OLD VEL(1) AND THAT OBTAINED FROM
C	VEL(1)=-INT/SLOPE, TO MAKE SURE THAT VEL(1) STAYS WITHIN
C	THE M>=1 FIELD.

	if (mach(i).gt.1.000) then
          write (6,1425)
          write (9,1425)
1425		format(5x,' mach number > 1.  adjusting initial velocity')
	  zlm(im) = z(i)-zfinal
	  v1m(im) = vel(1)
	  if (v1m(im).lt.rminv) rminv = v1m(im)

C	CALCULATE SLOPE AND INTERCEPT OF V(1) VS (Z(I)-ZFINAL) LINE,
C	AND VALUE OF V(1) ALONG THIS LINE WHEN Z(I)=0.  

	  if (im.ge.2) then
	    slope = (zlm(im)-zlm(im-1))/(v1m(im)-v1m(im-1))
	    int = zlm(im)-slope*v1m(im)
	    vel(1) = -int/slope + 0.1*(min(v1m(im),v1m(im-1))+
     *			int/slope)
	    if ((vel(1).gt.rminv).or.(vel(1).lt.rmaxo)) then
			 vel(1)=rmaxo+0.5*(rminv-rmaxo)
	    end if
	   else 
	    vel(1) = -vel(1)*(z(i)-z(1))/z(1) 
	  end if
	  im = im+1

C	FOR P<PFINAL, ADJUST V(1).  ASSUME, AS WHEN M>1, THAT THE
C	RELATIONSHIP BETWEEN V(1) AND Z(I) IS LINEAR.  CALCULATE V(1)
C	ALONG THIS LINE FOR Z(I)=ZFINAL.

	else if (pres(i).lt.pfinal) then
          write (6,5635) 
          write (9,5635)
5635		format(5x,'pressure is less than pfinal.',
     *			'  adjusting initial velocity')
	    zlp(ip) = z(i)-zfinal
	    v1p(ip) = vel(1)
	    if (vel(1).lt.rminv) rminv = vel(1)
	    if (ip.ge.2) then
	      slope = (zlp(ip)-zlp(ip-1))/(v1p(ip)-v1p(ip-1))
	      int = zlp(ip)-slope*v1p(ip)

C		  THE FOLLOWING STATEMENTS AVOID FLOATING-POINT DIVIDE ERRORS
		  crit = -9999.
		  if (slope.ne.0.) crit=-int/slope
	      if ((crit.le.0.).or.(crit.gt.vel(1))) then
		    vel(1) = vel(1)/2.
	       else
	    	vel(1) = -int/slope
	      end if
	    else
	    vel(1) = vel(1)*(z(i)-z(1))/(zfinal-z(1)) 
	  end if
	  if (vel(1).le.0.001) vel(1)=0.001
	  if (vel(1).lt.rmaxo) vel(1) = (rminv+rmaxo)/2.
	  ip = ip+1
	end if

C	IF THE MINIMUM OF V1P OR V1M AND THE MAXIMUM OF V1O DON'T DIFFER BY MORE
C	THAN .001 m/s, (AND THE SOLUTION LIES NEAR THE SURFACE) THEN CALL THE SOLUTION GOOD.

500	continue

	if ((((rmaxo.gt.0.).and.((rminv-rmaxo).lt.0.001)).or.
     *	(abs(vel(1)-vellast).lt.0.001)).and.(z(i).gt.(zfinal-5.))) 
     *	then
			write(6,5465)
			write(9,5465)
5465			format(/,5x,'initil velocities for succeeding runs',
     *				' differ by <0.001 m/s. Program stopped.',/)
			iend=1
			return
	end if

C	RE-INITIALIZE VARIABLES AND WRITE OUT NEW INITIAL VELOCITY

	do 100 j=1,i
	  re(j) = 0.
	  rho(j) = 0.
	  mach(j) = 0.
	  vesic(j) = 0.
	  visc(j) = 0.
100	continue
	do 200 j=2,i
	  vel(j) = 0.
	  pres(j) = 0.
	  z(j) = 0.
200	continue
	i = 1
	write (6,1044) vel(1)
	write (9,1044) vel(1)
1044    format (/,' trying new input velocity ',f10.5,' m/s',/)

	return
	end
